# singleton.rb

Path: | singleton.rb
Last Update: | Sat Oct 15 23:44:28 AUS Eastern Standard Time 2005

The Singleton module implements the Singleton pattern.

Usage:

       class Klass
          include Singleton
          # ...
       end

- this ensures that only one instance of Klass lets call it ``the instance’’ can be created.

  a,b = Klass.instance, Klass.instance a == b # => true a.new # NoMethodError - new is private …

- ``The instance’’ is created at instantiation time, in other words the first call of Klass.instance(), thus

        class OtherKlass
          include Singleton
          # ...
        end
        ObjectSpace.each_object(OtherKlass){} # => 0.

- This behavior is preserved under inheritance and cloning.

This is achieved by marking

- Klass.new and Klass.allocate - as private

Providing (or modifying) the class methods

- Klass.inherited(sub_klass) and Klass.clone() - to ensure that the Singleton pattern is properly inherited and cloned.
- Klass.instance() - returning ``the instance’’. After a successful self modifying (normally the first) call the method body is a simple:

         def Klass.instance()
           return @__instance__
         end

- Klass._load(str) - calling Klass.instance()
- Klass._instantiate?() - returning ``the instance’’ or nil. This hook method puts a second (or nth) thread calling Klass.instance() on a waiting loop. The return value signifies the successful completion or premature termination of the first, or more generally, current "instantiation thread".

The instance method of Singleton are

- clone and dup - raising TypeErrors to prevent cloning or duping
- _dump(depth) - returning the empty string. Marshalling strips by default all state information, e.g. instance variables and taint state, from ``the instance’’. Providing custom _load(str) and _dump(depth) hooks allows the (partially) resurrections of a previous state of ``the instance’’.

### Methods

__init__

### Public Instance methods

__init__(klass)

[Source]

    # File singleton.rb, line 157
      def __init__(klass)
        klass.instance_eval { @__instance__ = nil }
        class << klass
          define_method(:instance,FirstInstanceCall)
        end
        klass
      end

[Validate]